diff --git a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
index c4096ea8e..c77053c8d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
@@ -2,13 +2,13 @@ package net.minecraft.core.world.type.nether;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderNether;
-import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.nether.ChunkGeneratorNether;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldTypeNether
         extends WorldType {
@@ -48,6 +48,11 @@ public class WorldTypeNether
         return new BiomeProviderNether(world.getRandomSeed());
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return BiomeProviderNether.allBiomes();
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorNether(world);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
index 00f21012b..2e98e3b02 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
@@ -2,11 +2,13 @@ package net.minecraft.core.world.type.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.flat.ChunkGeneratorFlat;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldTypeFlat
         extends WorldTypeOverworld {
@@ -19,6 +21,11 @@ public class WorldTypeFlat
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 0.5, 0.0, 0.0);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return new Biome[] { Biomes.OVERWORLD_PLAINS };
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorFlat(world);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
index f203f4580..d401efce2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -3,10 +3,9 @@ package net.minecraft.core.world.type.overworld;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
-import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.ChunkGeneratorOverworld;
@@ -59,6 +58,11 @@ public class WorldTypeOverworld
         return new BiomeProviderOverworld(world.getRandomSeed(), this);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return BiomeProviderOverworld.allBiomes();
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorOverworld(world);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java
index 8736d2c1c..5365694fd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java
@@ -1,13 +1,12 @@
 package net.minecraft.core.world.type.overworld;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderB173;
-import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.b173.ChunkGeneratorOverworldB173;
-import net.minecraft.core.world.generate.chunk.perlin.overworld.retro.ChunkGeneratorOverworldRetro;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldTypeOverworldB173
         extends WorldTypeOverworld {
@@ -20,6 +19,11 @@ public class WorldTypeOverworldB173
         return new BiomeProviderB173(world.getRandomSeed());
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return BiomeProviderB173.allBiomes();
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorOverworldB173(world);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
index af5134ee1..6e59dace9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
@@ -1,12 +1,14 @@
 package net.minecraft.core.world.type.overworld;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.classic.ChunkGeneratorClassic;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldTypeOverworldClassic
         extends WorldTypeOverworld {
@@ -19,6 +21,11 @@ public class WorldTypeOverworldClassic
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return new Biome[] { Biomes.OVERWORLD_RETRO };
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorClassic(world);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
index 771e3419c..faf55ee91 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
@@ -1,11 +1,13 @@
 package net.minecraft.core.world.type.overworld;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.hell.ChunkGeneratorOverworldHell;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldTypeOverworldHell
         extends WorldTypeOverworld {
@@ -25,6 +27,11 @@ public class WorldTypeOverworldHell
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_HELL, 1.0, 1.0, 0.0);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return new Biome[] { Biomes.OVERWORLD_HELL };
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorOverworldHell(world);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
index cd0b6da88..12451aa1f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.type.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
@@ -10,6 +11,8 @@ import net.minecraft.core.world.generate.chunk.indev.ChunkGeneratorIndev;
 import net.minecraft.core.world.generate.chunk.indev.IndevWorldTheme;
 import net.minecraft.core.world.generate.chunk.indev.IndevWorldType;
 import net.minecraft.core.world.generate.chunk.indev.LevelGenerator;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -25,7 +28,7 @@ public class WorldTypeOverworldIndev
     }
 
     @Override
-    public void getInitialSpawnLocation(World world) {
+    public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
         int x;
         int y;
         int z;
@@ -54,6 +57,11 @@ public class WorldTypeOverworldIndev
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return new Biome[] { Biomes.OVERWORLD_RETRO };
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorIndev(world, 256, getMaxY() + 1, 256, IndevWorldType.ISLAND, IndevWorldTheme.NORMAL);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
index 18e81b245..e91e9ba7b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
@@ -1,11 +1,13 @@
 package net.minecraft.core.world.type.overworld;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.retro.ChunkGeneratorOverworldRetro;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldTypeOverworldRetro
         extends WorldTypeOverworld {
@@ -18,6 +20,11 @@ public class WorldTypeOverworldRetro
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return new Biome[] { Biomes.OVERWORLD_RETRO };
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorOverworldRetro(world);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
index 50f5f00a3..f78a5c4d0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
@@ -1,11 +1,14 @@
 package net.minecraft.core.world.type.overworld;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.skyblock.ChunkGeneratorSkyblock;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class WorldTypeOverworldSkyblock
         extends WorldTypeOverworld {
@@ -18,6 +21,11 @@ public class WorldTypeOverworldSkyblock
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
+    @Override
+    public @NotNull Biome @NotNull [] allBiomes() {
+        return new Biome[] { Biomes.OVERWORLD_PLAINS };
+    }
+
     @Override
     public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorSkyblock(world);
@@ -29,7 +37,7 @@ public class WorldTypeOverworldSkyblock
     }
 
     @Override
-    public void getInitialSpawnLocation(World world) {
+    public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
         world.getLevelData().setSpawn(0, 66, 0);
     }
 
diff --git a/game/core/src/main/resources/lang/en_US/biomes.lang b/game/core/src/main/resources/lang/en_US/biomes.lang
index 4ccddd7a8..c32253e38 100644
--- a/game/core/src/main/resources/lang/en_US/biomes.lang
+++ b/game/core/src/main/resources/lang/en_US/biomes.lang
@@ -27,4 +27,14 @@ biome.nether.sulfur_pools=Sulfur Pools
 biome.nether.crystal_forest=Crystal Forest
 biome.nether.ash_plains=Ash Plains
 biome.nether.boneyard=Boneyard
-biome.drift.drift=Drift
\ No newline at end of file
+biome.drift.drift=Drift
+
+biome.overworld.legacy.tundra=Beta Tundra
+biome.overworld.legacy.savanna=Beta Savanna
+biome.overworld.legacy.desert=Beta Desert
+biome.overworld.legacy.swampland=Beta Swampland
+biome.overworld.legacy.taiga=Beta Taiga
+biome.overworld.legacy.shrubland=Beta Shrubland
+biome.overworld.legacy.forest=Beta Forest
+biome.overworld.legacy.seasonal_forest=Beta Seasonal Forest
+biome.overworld.legacy.rainforest=Beta Rainforest
\ No newline at end of file
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index 4fa3f6de4..c688f7e61 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -102,6 +102,13 @@ gui.world_settings.page.game_rules.title=Game Rules
 gui.world_settings.page.world_settings.title=World Settings
 gui.world_settings.page.game_rules.button.on=ON
 gui.world_settings.page.game_rules.button.off=OFF
+gui.world_settings.page.mob_spawning.title=Mob Spawning
+gui.world_settings.page.mob_spawning.button.on=ON
+gui.world_settings.page.mob_spawning.button.off=OFF
+gui.world_settings.page.mob_spawning.hostile=Hostile Spawns
+gui.world_settings.page.mob_spawning.passive=Passive Spawns
+gui.world_settings.label.starting_biome=Starting Biome
+gui.world_settings.page.starting_biome.biome.none=Any
 gui.world_settings.label.select_world_type=Select World Type
 gui.world_settings.label.world_type=World Type
 
@@ -274,6 +281,7 @@ gui.options.page.debug.button.crash.soft=Crash Soft
 gui.options.page.debug.button.crash.hard=Crash Hard
 gui.options.page.debug.button.music.skip=Force Ambient Music
 gui.options.page.debug.button.garbage_collect=Run Garbage Collector
+gui.options.page.debug.button.reload_commands=Reload Commands
 
 gui.options.page.search.title=Search
 
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index d718e3486..845578e3b 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -49,6 +49,27 @@ options.guiScale.normal=Normal
 options.guiScale.large=Large
 options.advancedOpengl=Advanced OpenGL
 options.treeShadows=Leaf Shadowing
+options.transparencyDepthCheck=Translucent Depth Check
+options.particleQuality=Particle Quality
+options.particleQuality.all=All
+options.particleQuality.reduced=Reduced
+options.particleQuality.none=None
+options.particleCap=Max Particles
+options.particleRenderDistance=Particle Render Distance
+options.particleRenderDistance.default=Default
+options.chunkRebuilds=Chunk Rebuilds Per Frame
+options.frustumCulling=Frustum Culling
+options.entityShadows=Entity Shadows
+options.textOutlineQuality=Text Outline Quality
+options.textOutlineQuality.fast=Fast
+options.textOutlineQuality.fancy=Fancy
+options.cloudQuality=Cloud Quality
+options.cloudQuality.fast=Fast
+options.cloudQuality.fancy=Fancy
+options.leavesQuality=Leaves Quality
+options.leavesQuality.fancy=Fancy
+options.leavesQuality.smart=Smart
+options.leavesQuality.fast=Fast
 options.mods=Texture Packs...
 options.visuals=Visuals...
 options.visualsTitle=Visuals
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index 86abe3c9b..a3ea0fdd1 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -678,7 +678,7 @@ public class PlayerServer extends Player implements ContainerListener {
     }
 
     @Override
-	public void addStat(Stat stat, int i)
+	public void addStat(@Nullable Stat stat, int i)
     {
         if (stat == null)
         {
diff --git a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index d79dcb677..896e67870 100644
--- a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -214,21 +214,18 @@ public class ServerPlayerController
      * <p>
      * (i.e. throwing a fishing rod or shooting a bow)
      */
-    public boolean useItemStackOnNothing(Player entityplayer, World world, ItemStack itemstack)
+    public boolean useItemStackOnNothing(@NotNull Player player, @NotNull World world, @NotNull ItemStack itemstack)
     {
-        if (!entityplayer.getGamemode().canInteract()) return false;
+        if (!player.getGamemode().canInteract()) return false;
         int i = itemstack.stackSize;
-        ItemStack itemstack1 = itemstack.useItemRightClick(world, entityplayer);
-        if(itemstack1 != itemstack || itemstack1 != null && itemstack1.stackSize != i)
-        {
-            entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentSlot()] = itemstack1;
-            if(itemstack1.stackSize <= 0)
-            {
-                entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentSlot()] = null;
+        ItemStack resultStack = itemstack.useItem(world, player);
+        if(resultStack != itemstack || resultStack.stackSize != i) {
+            player.inventory.mainInventory[player.inventory.getCurrentSlot()] = resultStack;
+            if(resultStack == null || resultStack.stackSize <= 0) {
+                player.inventory.mainInventory[player.inventory.getCurrentSlot()] = null;
             }
             return true;
-        } else
-        {
+        } else {
             return false;
         }
     }
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 0de63e586..07cb884d0 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -1,27 +1,38 @@
 package net.minecraft.server.world;
 
-import java.util.ArrayList;
-import java.util.List;
-
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.world.*;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.net.packet.PacketBlockEvent;
+import net.minecraft.core.net.packet.PacketChat;
+import net.minecraft.core.net.packet.PacketCustomPayload;
+import net.minecraft.core.net.packet.PacketEntityEvent;
+import net.minecraft.core.net.packet.PacketEntityTagData;
+import net.minecraft.core.net.packet.PacketExplosion;
+import net.minecraft.core.net.packet.PacketWeatherEffect;
+import net.minecraft.core.net.packet.PacketWeatherStatus;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.net.packet.*;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.Explosion;
+import net.minecraft.core.world.ExplosionCannonball;
+import net.minecraft.core.world.SpawnerMobs;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.pos.TilePosc;
-import net.minecraft.server.world.chunk.provider.ChunkProviderServer;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.world.chunk.provider.ChunkProviderServer;
 import org.jetbrains.annotations.NotNull;
 
+import java.util.ArrayList;
+import java.util.List;
+
 public class WorldServer extends World
 {
     public ChunkProviderServer chunkProviderServer;
@@ -33,7 +44,7 @@ public class WorldServer extends World
 
     public WorldServer(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed)
     {
-        super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType);
+        super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType, null);
         entityIntHashMap = new Int2ObjectOpenHashMap<>();
         mcServer = minecraftserver;
         getLevelData().setLastPlayerUUID(null);
